template make(S) {
    S make(typeof(S.tupleof) v) {
        static assert(is (S == struct));
        S r;
        foreach (i, x; v) {
            r.tupleof[i] = x;
        }
        return r;
    }
}
template ctor() {
    static if (is (typeof(*this) S)) {
        static S opCall(typeof(S.tupleof) v) {
            static assert(is (S == struct));
            S r;
            foreach (i, x; v) {
                r.tupleof[i] = x;
            }
            return r;
        }
    }
    else {
        static assert(is (typeof(this) == class));
        this(typeof(S.tupleof) v) {
            foreach (i, x; v) {
                this.tupleof[i] = x;
            }
        }
    }
}

struct S {
    int i;
    string s;
    mixin ctor;
}

class C {
    int i;
    string s;
    mixin ctor;
}

class SL {
//    S[] ss;
    int i;
    string s;
    mixin ctor;
}

version (TEST_ERRORS) {
    alias ctor!() o;
}

void main() {
    S s = make!(S)(1, "hoge");
    assert(s.i == 1);
    assert(s.s == "hoge");

    assert(S(2, "hige").i == 2);
    assert(S(2, "hige").s == "hige");

    assert((new C(2, "hige")).i == 2);
    assert((new C(2, "hige")).s == "hige");
    new SL(3, "ge");
}
